
/*  Detonation  */

#include <SDL/SDL.h>
#include <SDL_mixer.h>
#include "SDL_musaluokka.h"
#include <stdlib.h>
#include <math.h>
#include <time.h>


#pragma comment(lib, "SDLmain.lib")
#pragma comment(lib, "SDL.lib")
#pragma comment(lib, "SDL_Mixer.lib")

SDL_Surface *screen;

const double pi=3.14159;

int i, ii, i2, ii2, a, x, y, boy_x;
double di;

int R, G, B;

class rocket //rakettiin liittyvt muuttujat
{
public:
	int x;
	int y;
	double pixel_x[100];
	double pixel_y[100];
	double p_speed_x[100];
	double p_speed_y[100];
	int rocket_counter;
	int pixel_counter;
	int place;
	double timer;
};

class kipina // kipinmuuttujat
{
public:
	double x, y;
	int suunta;
	int counter;
	int vari;
};


void DrawIMG(SDL_Surface *img, int x, int y)  //kuvaan tarvittavat funktiot
{
	SDL_Rect dest;
	dest.x = x;
	dest.y = y;
	SDL_BlitSurface(img, NULL, screen, &dest);
}

void DrawIMG(SDL_Surface *img, int x, int y, int w, int h, int x2, int y2) 
{ 
	SDL_Rect dest; 
	dest.x = x; 
	dest.y = y; 
	SDL_Rect dest2; 
	dest2.x = x2; 
	dest2.y = y2; 
	dest2.w = w; 
	dest2.h = h; 
	SDL_BlitSurface(img, &dest2, screen, &dest); 
} 

int SDL_BlitSurface(SDL_Surface *src, SDL_Rect *srcrect, 
					SDL_Surface *dst, SDL_Rect *dstrect); 




int main(int argc, char *argv[]) 
{ 

    if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO) < 0)  // SDL
    { 
        printf("Error to Init yms.. %s\n", SDL_GetError()); 
        exit(1); 

    } 

    if(Mix_OpenAudio(44100, MIX_DEFAULT_FORMAT, 2, 1024)==-1) {  //SDL_Mixer
        return 0;
    }

    atexit(SDL_Quit); 

	screen = SDL_SetVideoMode(800, 600, 32, SDL_HWSURFACE);

    if (screen == NULL) { 
        printf("Unable to set video mode.. sry .. &s\n", SDL_GetError()); 
        exit(1); 
    }

	SDL_WM_SetCaption("Detonation - Demo          Made By:  Touho", NULL);

	Uint8 *keys; //muuttujia
	Uint32 *bufp;
	SDL_Event event;

	bool muuttuja=0;
	bool loop=1;
	int pituus=40;

	kipina kipinat[3];


	for(i=0;i<3;i++)
		kipinat[i].counter=i;

	rocket rockets[100];

	double t_counter;

	for(i=0;i<100;i++)  //ilotulituksiin tarvittavia tietoja
	for(ii=0;ii<100;ii++)
	{
		rockets[i].p_speed_x[ii]=(rand() % 400);
		rockets[i].p_speed_y[ii]=(100 + rand() % 400);

		rockets[i].p_speed_x[ii]/=100;
		rockets[i].p_speed_y[ii]/=100;
			
		rockets[i].p_speed_x[ii]-=2;
		rockets[i].p_speed_y[ii]-=4;	
	}


	Musa Boom("Sound/boom.ogg", 1); //musaa
	Musa Vihellys("Sound/whistle.ogg", 1);
	Musa Poks("Sound/bop.ogg", 2);
	Boom.Voimakkuus(40);

	
	int starx[100]; //thtien koordinaatit
	int stary[100];

	double random[210];
	bool joo=0;
	double laskuri=0;
	int loppuluku=0;
	int arvottu=10+rand()%100;

	for(i=0;i<200;i++) //kiihtyv random
	{
		random[i]=1+i/30;
	}


		for(i=0;i<100;i++)//ilotulituksiin tarvittavia tietoja
		{
			starx[i] = 10 + rand() % 780;
			stary[i] = 10 + rand() % 500;
			rockets[i].y=493;
			rockets[i].x=120 + rand() % 400;
			rockets[i].place=1;
			rockets[i].timer= 20+ rand()%200;
			rockets[i].timer/=10;				
		}

		SDL_FillRect(screen,NULL,0x252830);


		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;

		for(i=1;i<30;i++) //kipinit
		for(ii=1;ii<360;ii+=1)
		{
			x=(int)(sin(ii*pi/180)*i);
			y=-(int)(cos(ii*pi/180)*i);
			bufp = (Uint32 *)screen->pixels + (300-y)*screen->pitch/4+400+x;
			*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
		}

		for(x=390;x<410;x++)
		for(y=260;y<280;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
		}

		SDL_Flip(screen);
	
		while ( loop )  // tuli irti!
		{

			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;


			for(y=40;y>0;y--)
			for(x=1;x<=2;x++)
			{
				bufp = (Uint32 *)screen->pixels + (260-y)*screen->pitch/4+399+x;
				*bufp = SDL_MapRGB(screen->format, 37, 40, 43);
			}


			for(y=pituus;y>0;y--)
			for(x=1;x<=2;x++)
			{
				bufp = (Uint32 *)screen->pixels + (260-y)*screen->pitch/4+399+x;
				*bufp = SDL_MapRGB(screen->format, 100, 100, 95);
			}


			for(i=0;i<3;i++)
			{
				if(kipinat[i].counter==3)
				{
					kipinat[i].counter=1;

					bufp = (Uint32 *)screen->pixels + ((int)kipinat[i].y)*screen->pitch/4+(int)kipinat[i].x;
					*bufp = SDL_MapRGB(screen->format, 35, 38, 40);

					kipinat[i].x=400;
					kipinat[i].y=260-pituus;
				}
		
				else
				{

					bufp = (Uint32 *)screen->pixels + ((int)kipinat[i].y)*screen->pitch/4+(int)kipinat[i].x;
					*bufp = SDL_MapRGB(screen->format, 35, 38, 40);

					kipinat[i].counter++;

					kipinat[i].y-=5;
					if(i==1)kipinat[i].x-=2;
					if(i==2)kipinat[i].x+=2;
					
				}
			}

			
			for(i=0;i<3;i++)
			{
				if(i==0)
				{
					bufp = (Uint32 *)screen->pixels + ((int)kipinat[i].y)*screen->pitch/4+(int)kipinat[i].x;
					*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
				}
				if(i==1)
				{
					bufp = (Uint32 *)screen->pixels + ((int)kipinat[i].y)*screen->pitch/4+(int)kipinat[i].x;
					*bufp = SDL_MapRGB(screen->format, 250, 250, 0);
				}
				if(i==2)
				{
					bufp = (Uint32 *)screen->pixels + ((int)kipinat[i].y)*screen->pitch/4+(int)kipinat[i].x;
					*bufp = SDL_MapRGB(screen->format, 200, 255, 0);
				}
			}


	
			SDL_Flip(screen);
		

			SDL_Delay(100);
			pituus-=1;
			if(pituus==0)loop=0;
		}

		loop=1;
		Boom.Toista(0);

		for(a=0;a<255;a+=20)
		{
			for(x=0;x<800;x++)
			for(y=0;y<600;y++)
			{
				bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
				*bufp = SDL_MapRGB(screen->format, 255, a, a);
			}

			for(i=0;i<200;i++)
			for(ii=1;ii<360;ii+=1)
			{
				x=(int)(sin(ii*pi/180)*i);
				y=-(int)(cos(ii*pi/180)*i);
				bufp = (Uint32 *)screen->pixels + (300-y)*screen->pitch/4+400+x;
				*bufp = SDL_MapRGB(screen->format, 255, 255, a);
		
			}
	
			SDL_Flip(screen);
	
			SDL_Delay(50);

			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;

		}

		SDL_FillRect(screen,NULL,0xffffff);

		DrawIMG(SDL_LoadBMP("Images/Happy.bmp"), 90, 100);

		SDL_Flip(screen);




		for(i=0;i<300;i++)
		{
			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;

			SDL_Delay(10);
		}

		SDL_FillRect(screen,NULL,0xffffff);


		for(a=255;a>0;a-=20)
		{
			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;

			for(x=0;x<800;x++)
			for(y=0;y<600;y++)
			{
				bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
				*bufp = SDL_MapRGB(screen->format, a, a, a);
			}

			SDL_Flip(screen);
			SDL_Delay(20);
		}


  

		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;


		SDL_FillRect(screen,NULL,0x000000);

		for(i=0;i<100;i++)
		{
			bufp = (Uint32 *)screen->pixels + (stary[i])*screen->pitch/4+starx[i];
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		for(x=0;x<800;x++)
		for(y=500;y<600;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 100, 428);
		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 600, 428);

		for(y=495;y<500;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+350;
			*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
		}
		for(x=349;x<352;x++)
		for(y=489;y<495;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
		}
		for(y=487;y<490;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+350;
			*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
		}


		SDL_Flip(screen);




		for(i=0;i<200;i++)
		{
			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;

			SDL_Delay(10);
		}


	for(boy_x=600;boy_x>355;boy_x-=2)
	{

		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;


		SDL_FillRect(screen,NULL,0x000000);

		for(i=0;i<100;i++)
		{
			bufp = (Uint32 *)screen->pixels + (stary[i])*screen->pitch/4+starx[i];
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		for(x=0;x<800;x++)
		for(y=500;y<600;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		DrawIMG(SDL_LoadBMP("Images/boy.bmp"), boy_x, 463);


		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 100, 428);
		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 600, 428);

		for(y=495;y<500;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+350;
			*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
		}
		for(x=349;x<352;x++)
		for(y=489;y<495;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
		}
		for(y=487;y<490;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+350;
			*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
		}

		SDL_Flip(screen);

		SDL_Delay(10);
	}

		for(i=0;i<100;i++)
		{
			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;

			SDL_Delay(10);
		}


	for(boy_x=355;boy_x>135;boy_x-=4)
	{

		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;


		SDL_FillRect(screen,NULL,0x000000);

		for(i=0;i<100;i++)
		{
			bufp = (Uint32 *)screen->pixels + (stary[i])*screen->pitch/4+starx[i];
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		for(x=0;x<800;x++)
		for(y=500;y<600;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		DrawIMG(SDL_LoadBMP("Images/boy.bmp"), boy_x, 463);


		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 100, 428);
		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 600, 428);



		for(y=495;y<500;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+350;
			*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
		}
		for(x=349;x<352;x++)
		for(y=489;y<495;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
		}
		for(y=487;y<490;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+350;
			*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
		}


		SDL_Flip(screen);

		SDL_Delay(10);
	}

		for(i=0;i<200;i++)
		{
			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;

			SDL_Delay(10);
		}
		
		rockets[0].y=493;
		rockets[0].x=350;
		Vihellys.Toista(0);

		for(rockets[0].rocket_counter=80;rockets[0].rocket_counter>0;rockets[0].rocket_counter--)
		{

			for(y=rockets[0].y+2;y<rockets[0].y+7;y++)
			{
				bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[0].x;
				*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
			}
			for(x=rockets[0].x-1;x<rockets[0].x+2;x++)
			for(y=rockets[0].y-4;y<rockets[0].y+2;y++)
			{
				bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
				*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
			}
			for(y=rockets[0].y-6;y<rockets[0].y-3;y++)
			{
				bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[0].x;
				*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
			}

			rockets[0].y-=5;

			for(y=rockets[0].y+2;y<rockets[0].y+7;y++)
			{
				bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[0].x;
				*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
			}
			for(x=rockets[0].x-1;x<rockets[0].x+2;x++)
			for(y=rockets[0].y-4;y<rockets[0].y+2;y++)
			{
				bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
				*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
			}
			for(y=rockets[0].y-6;y<rockets[0].y-3;y++)
			{
				bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[0].x;
				*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
			}

		
			SDL_Flip(screen);
		
			SDL_Delay(10);

			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;
		}

		for(i=0;i<100;i++)
		{
			rockets[0].pixel_x[i]=x;
			rockets[0].pixel_y[i]=y;
		}

		for(i=0;i<10;i++)
		for(ii=0;ii<20;ii++)
		{
				bufp = (Uint32 *)screen->pixels + ((int)y+ii-10)*screen->pitch/4+(int)x+i-5;
				*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
		}

		Poks.Toista(0);

		for(rockets[0].pixel_counter=90;rockets[0].pixel_counter>0;rockets[0].pixel_counter--)
		{
			for(i=0;i<100;i++)
			{
				bufp = (Uint32 *)screen->pixels + ((int)rockets[0].pixel_y[i])*screen->pitch/4+(int)rockets[0].pixel_x[i];
				*bufp = SDL_MapRGB(screen->format, 0, 0, 0);


				rockets[0].pixel_x[i]+=rockets[0].p_speed_x[i];
				rockets[0].pixel_y[i]+=rockets[0].p_speed_y[i];

				if(i%4==0){R=255;G=0;B=0;}
				if(i%4==1){R=255;G=255;B=0;}
				if(i%4==2){R=100;G=100;B=255;}
				if(i%4==3){R=255;G=200;B=150;}

				bufp = (Uint32 *)screen->pixels + ((int)rockets[0].pixel_y[i])*screen->pitch/4+(int)rockets[0].pixel_x[i];
				*bufp = SDL_MapRGB(screen->format, R, G, B);

				rockets[0].p_speed_y[i]+=0.1;
			}


			SDL_Flip(screen);

			SDL_Delay(10);

			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;
		}

		for(i=0;i<100;i++)
		{
			bufp = (Uint32 *)screen->pixels + ((int)rockets[0].pixel_y[i])*screen->pitch/4+(int)rockets[0].pixel_x[i];
			*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
		}

		for(i=0;i<100;i++)
		{
			bufp = (Uint32 *)screen->pixels + (stary[i])*screen->pitch/4+starx[i];
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		for(x=0;x<800;x++)
		for(y=500;y<600;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 100, 428);
		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 600, 428);


		SDL_Flip(screen);

		for(i=0;i<100;i++)
		{
			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;

			SDL_Delay(10);
		}

		for(boy_x=135;boy_x>20;boy_x-=2)
		{

			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;


			SDL_FillRect(screen,NULL,0x000000);

			for(i=0;i<100;i++)
			{
				bufp = (Uint32 *)screen->pixels + (stary[i])*screen->pitch/4+starx[i];
				*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
			}

			for(x=0;x<800;x++)
			for(y=500;y<600;y++)
			{
				bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
				*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
			}

			DrawIMG(SDL_LoadBMP("Images/boy.bmp"), boy_x, 463);


			DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 100, 428);
			DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 600, 428);

			SDL_Flip(screen);

			SDL_Delay(10);
		}



		for(i=0;i<100;i++)
		{
			rockets[i].y=493;
			rockets[i].x=160 + rand() % 400;
			rockets[i].place=1;
			rockets[i].timer= 20+ rand()%200;
			rockets[i].timer/=10;
			rockets[i].rocket_counter= 30+rand()%60;
			rockets[i].pixel_counter=10+rand()%80;

			laskuri=0;
			loppuluku=0;
			arvottu=1000+rand()%1000;
			muuttuja=0;

			while(muuttuja==0)
			for(i2=0;i2<200;i2++)
			{
				laskuri+=random[i2];
				if(laskuri>arvottu && muuttuja==0)
				{  
					loppuluku=i2;
					muuttuja=1;
				}
			} 
			rockets[i].timer=loppuluku;
			rockets[i].timer/=10;
		}



	t_counter=(double)clock()/CLK_TCK;	

	while(1)
	{
		for(i=0;i<40;i++)
		{
			if(rockets[i].place==1)
			{
				if((double)clock()/CLK_TCK-t_counter > rockets[i].timer)
				{
					for(y=495;y<500;y++)
					{
						bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
						*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
					}
					for(x=rockets[i].x-1;x<rockets[i].x+2;x++)
					for(y=489;y<495;y++)
					{
						bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
						*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
					}
					for(y=487;y<490;y++)
					{
						bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
						*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
					}
					rockets[i].place=2;
					Vihellys.Toista(0);
				}

				for(y=495;y<500;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
				}
				for(x=rockets[i].x-1;x<rockets[i].x+2;x++)
				for(y=489;y<495;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
					*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
				}
				for(y=487;y<490;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
				}
			}


			if(rockets[i].place==2)
			{

				for(y=rockets[i].y+2;y<rockets[i].y+7;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}
				for(x=rockets[i].x-1;x<rockets[i].x+2;x++)
				for(y=rockets[i].y-4;y<rockets[i].y+2;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}
				for(y=rockets[i].y-6;y<rockets[i].y-3;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}

				
				if(rockets[i].rocket_counter<1)
				{
					rockets[i].place=3;

					for(ii=0;ii<100;ii++)
					{
						rockets[i].pixel_x[ii]=rockets[i].x;
						rockets[i].pixel_y[ii]=rockets[i].y;
					}

						for(ii=0;ii<100;ii++)
						{
							rockets[i].p_speed_x[ii]=(rand() % 400);
							rockets[i].p_speed_y[ii]=(100 + rand() % 400);

							rockets[i].p_speed_x[ii]/=100;
							rockets[i].p_speed_y[ii]/=100;
			
							rockets[i].p_speed_x[ii]-=2;
							rockets[i].p_speed_y[ii]-=4;	
						}
					Poks.Toista(0);
				}

				else
				{
				rockets[i].y-=5;

				for(y=rockets[i].y+2;y<rockets[i].y+7;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
				}
				for(x=rockets[i].x-1;x<rockets[i].x+2;x++)
				for(y=rockets[i].y-4;y<rockets[i].y+2;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
					*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
				}
				for(y=rockets[i].y-6;y<rockets[i].y-3;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
				}
				rockets[i].rocket_counter--;
				}
				
				
			}




			if(rockets[i].place==3)
			{
				if(rockets[i].pixel_counter<1)
				{
					rockets[i].place=4;

					for(ii=0;ii<100;ii++)		
					if(rockets[i].pixel_y[ii]<550 && rockets[i].pixel_y[ii]>0)
					{
						bufp = (Uint32 *)screen->pixels + ((int)rockets[i].pixel_y[ii])*screen->pitch/4+(int)rockets[i].pixel_x[ii];
						*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
					}
				}

				else
				{

					for(ii=0;ii<50;ii++)
					{
						if(rockets[i].pixel_y[ii]<550 && rockets[i].pixel_y[ii]>0)
						{
							bufp = (Uint32 *)screen->pixels + ((int)rockets[i].pixel_y[ii])*screen->pitch/4+(int)rockets[i].pixel_x[ii];
							*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
						}

						rockets[i].pixel_x[ii]+=rockets[i].p_speed_x[ii];
						rockets[i].pixel_y[ii]+=rockets[i].p_speed_y[ii];

						if(ii%4==0){R=255;G=0;B=0;}
						if(ii%4==1){R=255;G=255;B=0;}
						if(ii%4==2){R=100;G=100;B=255;}
						if(ii%4==3){R=255;G=200;B=150;}

						if(rockets[i].pixel_y[ii]<550 && rockets[i].pixel_y[ii]>0)
						{
							bufp = (Uint32 *)screen->pixels + ((int)rockets[i].pixel_y[ii])*screen->pitch/4+(int)rockets[i].pixel_x[ii];
							*bufp = SDL_MapRGB(screen->format, R, G, B);
						}

						rockets[i].p_speed_y[ii]+=0.1;
					}
					rockets[i].pixel_counter--;
				}
			}
		}

		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;

		for(i=0;i<100;i++)
		{
			bufp = (Uint32 *)screen->pixels + (stary[i])*screen->pitch/4+starx[i];
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		for(x=0;x<800;x++)
		for(y=500;y<600;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		DrawIMG(SDL_LoadBMP("Images/boy.bmp"), boy_x, 463);

		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 100, 428);
		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 600, 428);


		SDL_Flip(screen);

		SDL_Delay(10);

		if((double)clock()/CLK_TCK-t_counter>25)
			break;
	}

// SDETN RYTMIOSUUS


	for(i=0;i<100;i++)
	{
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(rand() % 400);
			rockets[i].p_speed_y[ii]=(100 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
			
			rockets[i].p_speed_x[ii]-=2;
			rockets[i].p_speed_y[ii]-=4;
			
			rockets[i].place=1;
			rockets[i].y=493;
			rockets[i].timer=16;
		}
	}



//SIVUJUTTU

i=1;
		rockets[i].pixel_counter=60; //uloin vasen
		rockets[i].rocket_counter=90;
		rockets[i].timer=2;
		rockets[i].x=150;
i++;
		rockets[i].pixel_counter=60; //uloin oikea
		rockets[i].rocket_counter=90;
		rockets[i].timer=2;
		rockets[i].x=550;


i++;
		rockets[i].pixel_counter=60;
		rockets[i].rocket_counter=70;
		rockets[i].timer=3;
		rockets[i].x=200;
i++;
		rockets[i].pixel_counter=60;
		rockets[i].rocket_counter=70;
		rockets[i].timer=3;
		rockets[i].x=500;


i++;
		rockets[i].pixel_counter=60;
		rockets[i].rocket_counter=50;
		rockets[i].timer=4;
		rockets[i].x=300;
i++;
		rockets[i].pixel_counter=60;
		rockets[i].rocket_counter=50;
		rockets[i].timer=4;
		rockets[i].x=400;


i++;
		rockets[i].pixel_counter=60;
		rockets[i].rocket_counter=30;
		rockets[i].timer=5;
		rockets[i].x=330;
i++;
		rockets[i].pixel_counter=60;
		rockets[i].rocket_counter=30;
		rockets[i].timer=5;
		rockets[i].x=370;



// KESKI

i++;
		rockets[i].pixel_counter=40;
		rockets[i].rocket_counter=10;
		rockets[i].timer=6;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=40;
		rockets[i].rocket_counter=20;
		rockets[i].timer=6;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=40;
		rockets[i].rocket_counter=30;
		rockets[i].timer=6;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=40;
		rockets[i].rocket_counter=40;
		rockets[i].timer=6;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=30;
		rockets[i].rocket_counter=50;
		rockets[i].timer=6;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=20;
		rockets[i].rocket_counter=60;
		rockets[i].timer=6;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=15;
		rockets[i].rocket_counter=70;
		rockets[i].timer=6;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=10;
		rockets[i].rocket_counter=80;
		rockets[i].timer=6;
		rockets[i].x=350;

i++;
		rockets[i].pixel_counter=100;  // POKS!
		rockets[i].rocket_counter=90;
		rockets[i].timer=6;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=120;
		rockets[i].rocket_counter=90;
		rockets[i].timer=6;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=130;
		rockets[i].rocket_counter=90;
		rockets[i].timer=6;
		rockets[i].x=350;


i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=9;
		rockets[i].x=120;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}

i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=9;
		rockets[i].x=620;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}


i++;
		rockets[i].pixel_counter=50;
		rockets[i].rocket_counter=50;
		rockets[i].timer=9;
		rockets[i].x=200;
i++;
		rockets[i].pixel_counter=50;
		rockets[i].rocket_counter=50;
		rockets[i].timer=9;
		rockets[i].x=500;

i++;
		rockets[i].pixel_counter=50;
		rockets[i].rocket_counter=70;
		rockets[i].timer=9;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=50;
		rockets[i].rocket_counter=80;
		rockets[i].timer=9;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=50;
		rockets[i].rocket_counter=0;
		rockets[i].timer=11.1;
		rockets[i].x=350;
i++;
		rockets[i].pixel_counter=50;
		rockets[i].rocket_counter=20;
		rockets[i].timer=11.1;
		rockets[i].x=350;


i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=12.5;
		rockets[i].x=120;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}
i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=12.5;
		rockets[i].x=620;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}
i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=12.5;
		rockets[i].x=120;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}
i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=12.5;
		rockets[i].x=620;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}


i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=13;
		rockets[i].x=120;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}
i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=13;
		rockets[i].x=620;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}
i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=13;
		rockets[i].x=120;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}
i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=0;
		rockets[i].timer=13;
		rockets[i].x=620;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 200);
			rockets[i].p_speed_y[ii]=(-600 + rand() % 400);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}



i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=90;
		rockets[i].timer=14;
		rockets[i].x=340;


		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-400+rand() % 800);
			rockets[i].p_speed_y[ii]=(-200 + rand() % 500);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
			
			
			rockets[i].place=1;
			rockets[i].y=493;

		}

i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=90;
		rockets[i].timer=14;
		rockets[i].x=360;


		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-400+rand() % 800);
			rockets[i].p_speed_y[ii]=(-200 + rand() % 500);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
			
			
			rockets[i].place=1;
			rockets[i].y=493;

		}

i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=90;
		rockets[i].timer=14;
		rockets[i].x=340;


		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-400+rand() % 800);
			rockets[i].p_speed_y[ii]=(-200 + rand() % 500);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
			
			
			rockets[i].place=1;
			rockets[i].y=493;

		}

i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=90;
		rockets[i].timer=14;
		rockets[i].x=360;


		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-400+rand() % 800);
			rockets[i].p_speed_y[ii]=(-200 + rand() % 500);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
			
			
			rockets[i].place=1;
			rockets[i].y=493;

		}

i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=90;
		rockets[i].timer=14;
		rockets[i].x=340;


		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-400+rand() % 800);
			rockets[i].p_speed_y[ii]=(-200 + rand() % 500);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
			
			
			rockets[i].place=1;
			rockets[i].y=493;

		}

i++;
		rockets[i].pixel_counter=100;
		rockets[i].rocket_counter=90;
		rockets[i].timer=14;
		rockets[i].x=360;


		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-400+rand() % 800);
			rockets[i].p_speed_y[ii]=(-200 + rand() % 500);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
			
			
			rockets[i].place=1;
			rockets[i].y=493;

		}


i++;
		rockets[i].pixel_counter=190;
		rockets[i].rocket_counter=0;
		rockets[i].timer=16;
		rockets[i].x=120;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 300);
			rockets[i].p_speed_y[ii]=(-1000 + rand() % 600);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}
i++;
		rockets[i].pixel_counter=190;
		rockets[i].rocket_counter=0;
		rockets[i].timer=16;
		rockets[i].x=620;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-200+rand() % 300);
			rockets[i].p_speed_y[ii]=(-1000 + rand() % 600);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}




i++;
		rockets[i].pixel_counter=200;
		rockets[i].rocket_counter=0;
		rockets[i].timer=16;
		rockets[i].x=120;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-100+rand() % 300);
			rockets[i].p_speed_y[ii]=(-1000 + rand() % 600);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}
i++;
		rockets[i].pixel_counter=200;
		rockets[i].rocket_counter=0;
		rockets[i].timer=16;
		rockets[i].x=620;
		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-200+rand() % 300);
			rockets[i].p_speed_y[ii]=(-1000 + rand() % 600);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
		}

for(i=46;i<60;i++)
{
		rockets[i].pixel_counter=300;
		rockets[i].rocket_counter=90;
		rockets[i].timer=14;
		rockets[i].x=340+rand()%20;

		for(ii=0;ii<100;ii++)
		{
			rockets[i].p_speed_x[ii]=(-400+rand() % 800);
			rockets[i].p_speed_y[ii]=(-500 + rand() % 1000);

			rockets[i].p_speed_x[ii]/=100;
			rockets[i].p_speed_y[ii]/=100;
			
			
			rockets[i].place=1;
			rockets[i].y=493;

		}
}

//huhhuh..


	for(boy_x=20;boy_x<720;boy_x+=3)
	{

		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;


		SDL_FillRect(screen,NULL,0x000000);

		for(i=0;i<100;i++)
		{
			bufp = (Uint32 *)screen->pixels + (stary[i])*screen->pitch/4+starx[i];
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		for(x=0;x<800;x++)
		for(y=500;y<600;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		DrawIMG(SDL_LoadBMP("Images/boy.bmp"), boy_x, 463);

		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 100, 428);
		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 600, 428);


		for(i=0;i<59;i++)
		{
			if(boy_x>rockets[i].x)
			{
				for(y=495;y<500;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
				}
				for(x=rockets[i].x-1;x<rockets[i].x+2;x++)
				for(y=489;y<495;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
					*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
				}
				for(y=487;y<490;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
				}
			}
		}

		SDL_Flip(screen);

		SDL_Delay(10);
	}

	t_counter=(double)clock()/CLK_TCK;

	while(1)
	{
		for(i=0;i<59;i++)
		{
			if(rockets[i].place==1)
			{
				if((double)clock()/CLK_TCK-t_counter > rockets[i].timer)
				{
					for(y=495;y<500;y++)
					{
						bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
						*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
					}
					for(x=rockets[i].x-1;x<rockets[i].x+2;x++)
					for(y=489;y<495;y++)
					{
						bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
						*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
					}
					for(y=487;y<490;y++)
					{
						bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
						*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
					}

					rockets[i].place=2;
					Vihellys.Toista(0);
				}

				for(y=495;y<500;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
				}
				for(x=rockets[i].x-1;x<rockets[i].x+2;x++)
				for(y=489;y<495;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
					*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
				}
				for(y=487;y<490;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
				}
			}





			if(rockets[i].place==2)
			{

				for(y=rockets[i].y+2;y<rockets[i].y+7;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}
				for(x=rockets[i].x-1;x<rockets[i].x+2;x++)
				for(y=rockets[i].y-4;y<rockets[i].y+2;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}
				for(y=rockets[i].y-6;y<rockets[i].y-3;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}

				
				if(rockets[i].rocket_counter<1)
				{
					rockets[i].place=3;

					for(ii=0;ii<100;ii++)
					{
						rockets[i].pixel_x[ii]=rockets[i].x;
						rockets[i].pixel_y[ii]=rockets[i].y;
					}
					Poks.Toista(0);
				}

				else
				{
					rockets[i].y-=5;

					for(y=rockets[i].y+2;y<rockets[i].y+7;y++)
					{
						bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
						*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
					}
					for(x=rockets[i].x-1;x<rockets[i].x+2;x++)
					for(y=rockets[i].y-4;y<rockets[i].y+2;y++)
					{
						bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
						*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
					}
					for(y=rockets[i].y-6;y<rockets[i].y-3;y++)
					{
						bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[i].x;
						*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
					}

					rockets[i].rocket_counter--;
				}
			}




			if(rockets[i].place==3)
			{
				if(rockets[i].pixel_counter<1)
				{
					rockets[i].place=4;

					for(ii=0;ii<100;ii++)
					{
						if(rockets[i].pixel_y[ii]<550 && rockets[i].pixel_y[ii]>0 && rockets[i].pixel_x[ii]<800 && rockets[i].pixel_x[ii] > 0)
						{
							bufp = (Uint32 *)screen->pixels + ((int)rockets[i].pixel_y[ii])*screen->pitch/4+(int)rockets[i].pixel_x[ii];
							*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
						}
					}
				}

				else
				{

					for(ii=0;ii<100;ii++)
					{
						if(rockets[i].pixel_y[ii]<550 && rockets[i].pixel_y[ii]>0 && rockets[i].pixel_x[ii]<800 && rockets[i].pixel_x[ii] > 0)
						{
							bufp = (Uint32 *)screen->pixels + ((int)rockets[i].pixel_y[ii])*screen->pitch/4+(int)rockets[i].pixel_x[ii];
							*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
						}

						rockets[i].pixel_x[ii]+=rockets[i].p_speed_x[ii];
						rockets[i].pixel_y[ii]+=rockets[i].p_speed_y[ii];

						if(ii%4==0){R=255;G=0;B=0;}
						if(ii%4==1){R=255;G=255;B=0;}
						if(ii%4==2){R=100;G=100;B=255;}
						if(ii%4==3){R=255;G=200;B=150;}

						if(rockets[i].pixel_y[ii]<550 && rockets[i].pixel_y[ii]>0 && rockets[i].pixel_x[ii]<800 && rockets[i].pixel_x[ii] > 0)
						{
							bufp = (Uint32 *)screen->pixels + ((int)rockets[i].pixel_y[ii])*screen->pitch/4+(int)rockets[i].pixel_x[ii];
							*bufp = SDL_MapRGB(screen->format, R, G, B);
						}

						rockets[i].p_speed_y[ii]+=0.1;
					}
					rockets[i].pixel_counter--;
				}
			}
		} 



		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;

		for(i=0;i<100;i++)
		{
			bufp = (Uint32 *)screen->pixels + (stary[i])*screen->pitch/4+starx[i];
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		for(x=0;x<800;x++)
		for(y=500;y<600;y++)
		{
			bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
			*bufp = SDL_MapRGB(screen->format, 255, 255, 255);
		}

		DrawIMG(SDL_LoadBMP("Images/boy.bmp"), boy_x, 463);

		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 100, 428);
		DrawIMG(SDL_LoadBMP("Images/tree.bmp"), 600, 428);


		SDL_Flip(screen);

		SDL_Delay(10);

		if((double)clock()/CLK_TCK-t_counter>24)
			break;
	}


	SDL_FillRect(screen,NULL,0x000000);

	DrawIMG(SDL_LoadBMP("Images/klo1.bmp"), 270, 230);
	SDL_Flip(screen);

	for(i=0;i<200;i++)
	{
		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;

		SDL_Delay(10);
	}

	DrawIMG(SDL_LoadBMP("Images/klo2.bmp"), 270, 230);

	SDL_Flip(screen);

	for(i=0;i<200;i++)
	{
		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;

			SDL_Delay(10);
		}

		DrawIMG(SDL_LoadBMP("Images/sleep.bmp"), 110, 100);
		SDL_Flip(screen);

		for(i=0;i<200;i++)
		{
			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;

			SDL_Delay(10);
		}

		rockets[0].y=493;
		rockets[0].x=350;
		Vihellys.Toista(0);

		for(rockets[0].rocket_counter=55;rockets[0].rocket_counter>0;rockets[0].rocket_counter--)
		{
			if(rockets[0].y<265)
			{
				for(y=rockets[0].y+2;y<rockets[0].y+7;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[0].x;
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}
				for(x=rockets[0].x-1;x<rockets[0].x+2;x++)
				for(y=rockets[0].y-4;y<rockets[0].y+2;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}
				for(y=rockets[0].y-6;y<rockets[0].y-3;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[0].x;
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}
			}

			rockets[0].y-=5;

			if(rockets[0].y<265)
			{
				for(y=rockets[0].y+2;y<rockets[0].y+7;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[0].x;
					*bufp = SDL_MapRGB(screen->format, 210, 180, 0);
				}
				for(x=rockets[0].x-1;x<rockets[0].x+2;x++)
				for(y=rockets[0].y-4;y<rockets[0].y+2;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+x;
					*bufp = SDL_MapRGB(screen->format, 250, 0, 0);
				}
				for(y=rockets[0].y-6;y<rockets[0].y-3;y++)
				{
					bufp = (Uint32 *)screen->pixels + (y)*screen->pitch/4+rockets[0].x;
					*bufp = SDL_MapRGB(screen->format, 255, 0, 0);
				}
			}

			SDL_Flip(screen);
		
			SDL_Delay(10);

			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;
		}

		for(i=0;i<100;i++)
		{
			rockets[0].pixel_x[i]=x;
			rockets[0].pixel_y[i]=y;
		}

		for(i=0;i<10;i++)
		for(ii=0;ii<20;ii++)
		{
				bufp = (Uint32 *)screen->pixels + ((int)y+ii-10)*screen->pitch/4+(int)x+i-5;
				*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
		}

		Poks.Toista(0);

		for(rockets[0].pixel_counter=90;rockets[0].pixel_counter>0;rockets[0].pixel_counter--)
		{
			for(i=0;i<100;i++)
			{
				if(rockets[0].pixel_y[i]<270 && rockets[0].pixel_x[i]<430 && rockets[0].pixel_x[i] > 258)
				{
					bufp = (Uint32 *)screen->pixels + ((int)rockets[0].pixel_y[i])*screen->pitch/4+(int)rockets[0].pixel_x[i];
					*bufp = SDL_MapRGB(screen->format, 0, 0, 0);
				}

				rockets[0].pixel_x[i]+=rockets[0].p_speed_x[i];
				rockets[0].pixel_y[i]+=rockets[0].p_speed_y[i];

				if(i%4==0){R=255;G=0;B=0;}
				if(i%4==1){R=255;G=255;B=0;}
				if(i%4==2){R=100;G=100;B=255;}
				if(i%4==3){R=255;G=200;B=150;}

				if(rockets[0].pixel_y[i]<270 && rockets[0].pixel_x[i]<430 && rockets[0].pixel_x[i] > 258)
				{
					bufp = (Uint32 *)screen->pixels + ((int)rockets[0].pixel_y[i])*screen->pitch/4+(int)rockets[0].pixel_x[i];
					*bufp = SDL_MapRGB(screen->format, R, G, B);
				}

				rockets[0].p_speed_y[i]+=0.1;
			}
			

			SDL_Flip(screen);

			SDL_Delay(10);

			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;
		}


		for(i=0;i<200;i++)
		{
			SDL_PollEvent(&event);
			if ( event.type == SDL_QUIT ) return 0; 
			keys = SDL_GetKeyState(NULL);
			if ( keys[SDLK_ESCAPE]) return 0;

			SDL_Delay(10);
		}

		SDL_FillRect(screen,NULL,0x000000);
		DrawIMG(SDL_LoadBMP("Images/end.bmp"), 160, 100);
		SDL_Flip(screen);



	while(1)
	{
		SDL_PollEvent(&event);
		if ( event.type == SDL_QUIT ) return 0; 
		keys = SDL_GetKeyState(NULL);
		if ( keys[SDLK_ESCAPE]) return 0;
	}


	return 0;
}